searchNodes=[{"ref":"Norm.html","title":"Norm","type":"module","doc":"Norm provides a set of functions for specifying data."},{"ref":"Norm.html#alt/1","title":"Norm.alt/1","type":"function","doc":"Choices between alternative predicates or patterns. The patterns must be tagged with an atom. When conforming data to this specification the data is returned as a tuple with the tag. Examples iex&gt; conform!(&quot;foo&quot;, alt(s: spec(is_binary()), a: spec(is_atom()))) iex&gt; conform!(:foo, alt(s: spec(is_binary()), a: spec(is_atom()))) iex&gt; conform!(123, alt(num: spec(is_integer()), str: spec(is_binary()))) iex&gt; conform!(&quot;foo&quot;, alt(num: spec(is_integer()), str: spec(is_binary()))) iex&gt; conform(true, alt(num: spec(is_integer()), str: spec(is_binary())))"},{"ref":"Norm.html#conform/2","title":"Norm.conform/2","type":"function","doc":"Verifies that the payload conforms to the specification Examples: iex&gt; conform(42, spec(is_integer())) iex&gt; conform(42, spec(fn x -&gt; x == 42 end)) iex&gt; conform(42, spec(&amp;(&amp;1 &gt;= 0))) iex&gt; conform(42, spec(&amp;(&amp;1 &gt;= 100))) iex&gt; conform(&quot;foo&quot;, spec(is_integer()))"},{"ref":"Norm.html#conform!/2","title":"Norm.conform!/2","type":"function","doc":"Verifies that the payload conforms to the specification or raises a Mismatch error"},{"ref":"Norm.html#gen/1","title":"Norm.gen/1","type":"function","doc":"Creates a generator from a spec or predicate. iex&gt; gen(spec(is_integer())) |&gt; Enum.take(3) |&gt; Enum.all?(&amp;is_integer/1) true iex&gt; gen(spec(is_binary())) |&gt; Enum.take(3) |&gt; Enum.all?(&amp;is_binary/1) true iex&gt; gen(spec(&amp;(&amp;1 &gt; 0))) ** (Norm.GeneratorError) Unable to create a generator for: &amp;(&amp;1 &gt; 0)"},{"ref":"Norm.html#schema/1","title":"Norm.schema/1","type":"function","doc":"Creates a re-usable schema."},{"ref":"Norm.html#selection/1","title":"Norm.selection/1","type":"function","doc":"Specifies a selection of keys from a schema. This allows callsites to define what keys must be available from the input."},{"ref":"Norm.html#selection/2","title":"Norm.selection/2","type":"function","doc":""},{"ref":"Norm.html#spec/1","title":"Norm.spec/1","type":"macro","doc":"Creates a new spec. Specs can be created from any existing predicates or anonymous functions. Specs must return a boolean value. Predicates can be arbitrarily composed using the and and or keywords. Examples: iex&gt; conform!(21, spec(is_integer())) 21 iex&gt; conform!(21, spec(is_integer() and &amp;(&amp;1 &gt;= 21))) 21 iex&gt; conform(&quot;21&quot;, spec(is_integer() and &amp;(&amp;1 &gt;= 21))) iex&gt; conform!(:foo, spec(is_atom() or is_binary())) :foo iex&gt; conform!(&quot;foo&quot;, spec(is_atom() or is_binary())) &quot;foo&quot; iex&gt; conform(21, spec(is_atom() or is_binary()))"},{"ref":"Norm.html#valid?/2","title":"Norm.valid?/2","type":"function","doc":"Checks if the value conforms to the spec and returns a boolean. iex&gt; valid?(42, spec(is_integer())) true iex&gt; valid?(&quot;foo&quot;, spec(is_integer())) false"},{"ref":"Norm.html#with_gen/2","title":"Norm.with_gen/2","type":"function","doc":"Overwrites the default generator with a custom generator. The generator can be any valid StreamData generator. This means you can either use Norms built in gen/1 function or you can drop into StreamData directly. Examples iex&gt; Enum.take(gen(with_gen(spec(is_integer()), StreamData.constant(&quot;hello world&quot;))), 3) [&quot;hello world&quot;, &quot;hello world&quot;, &quot;hello world&quot;]"},{"ref":"Norm.Conformer.Conformable.html","title":"Norm.Conformer.Conformable","type":"protocol","doc":"Defines a conformable type. Must take the type, current path, and input and return an success tuple with the conformed data or a list of errors."},{"ref":"Norm.Conformer.Conformable.html#conform/3","title":"Norm.Conformer.Conformable.conform/3","type":"function","doc":""},{"ref":"Norm.Conformer.Conformable.html#t:t/0","title":"Norm.Conformer.Conformable.t/0","type":"type","doc":""},{"ref":"Norm.Generatable.html","title":"Norm.Generatable","type":"protocol","doc":"Defines generatable types"},{"ref":"Norm.Generatable.html#gen/1","title":"Norm.Generatable.gen/1","type":"function","doc":""},{"ref":"Norm.Generatable.html#t:t/0","title":"Norm.Generatable.t/0","type":"type","doc":""},{"ref":"Norm.GeneratorError.html","title":"Norm.GeneratorError","type":"exception","doc":""},{"ref":"Norm.MismatchError.html","title":"Norm.MismatchError","type":"exception","doc":""},{"ref":"Norm.SpecError.html","title":"Norm.SpecError","type":"exception","doc":""}]